/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

(function(window) {

function createChecker(x, y, angles) {
    function angleInList(angle, list) {
        return list.map(item => Math.abs(item - angle)).reduce((prev, abs) => Math.min(prev, abs), Infinity) < 0.01;
    }

    return function() {
        if (!this.pfeile.length && angles.length)
            return 'Zeichne zuerst die fehlenden Spannkräfte ein…';
//const lastPfeil = this.pfeile[this.pfeile.length - 1];console.log({ x: lastPfeil.x1, y: lastPfeil.y1, angles: this.pfeile.map(pfeil => pfeil.angle / Math.PI) });return true;
        if (this.pfeile.reduce((prev, pfeil) => prev || pfeil.x1 != x || pfeil.y1 != y, false))
            return 'Der Angriffspunkt muss immer die Kugel sein';
        const userAngles = this.pfeile.map(pfeil => pfeil.angle / Math.PI);
        if (userAngles.reduce((prev, angle) => prev || !angleInList(angle, angles), false))
            return 'Nicht alle eingezeichneten Kräfte sind tatsächlich Spannkräfte';
        if (angles.reduce((prev, angle) => prev || !angleInList(angle, userAngles), false))
            return 'Nicht alle Spannkräfte sind eingezeichnet';
        return true;
    }
}

const LEVELS = [
    {
        "task": "<p>Neben, über oder unter der eigentlichen Zeichnung sind beteiligte Feder stets in Ruhelage eingezeichnet. Ergänze alle auf die Kugel wirkenden Spannkräfte.</p>",
        "shadows": [
            { type: 'image', src: 'szenario1.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "check": createChecker(65, 25, [-0.5])
    },
    {
        "task": "<p>Neben, über oder unter der eigentlichen Zeichnung sind beteiligte Feder stets in Ruhelage eingezeichnet. Ergänze alle auf die Kugel wirkenden Spannkräfte.</p>",
        "shadows": [
            { type: 'image', src: 'szenario2.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "check": createChecker(65, 15, [0.5])
    },
    {
        "task": "<p>Neben, über oder unter der eigentlichen Zeichnung sind beteiligte Feder stets in Ruhelage eingezeichnet. Ergänze alle auf die Kugel wirkenden Spannkräfte.</p>",
        "shadows": [
            { type: 'image', src: 'szenario3.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "check": createChecker(65, 30, [0.25])
    },
    {
        "task": "<p>Neben, über oder unter der eigentlichen Zeichnung sind beteiligte Feder stets in Ruhelage eingezeichnet. Ergänze alle auf die Kugel wirkenden Spannkräfte.</p>",
        "shadows": [
            { type: 'image', src: 'szenario4.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "check": createChecker(50, 20, [0, 1])
    },
    {
        "task": "<p>Neben, über oder unter der eigentlichen Zeichnung sind beteiligte Feder stets in Ruhelage eingezeichnet. Ergänze alle auf die Kugel wirkenden Spannkräfte.</p>",
        "shadows": [
            { type: 'image', src: 'szenario5.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "check": createChecker(50, 30, [0, 1])
    },
    {
        "task": "<p>Neben, über oder unter der eigentlichen Zeichnung sind beteiligte Feder stets in Ruhelage eingezeichnet. Ergänze alle auf die Kugel wirkenden Spannkräfte.</p>",
        "shadows": [
            { type: 'image', src: 'szenario6.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "check": createChecker(45, 30, [0, -0.25])
    }
];

window.karokonstruktionTask = {
    levels: LEVELS
};
})(window);
